# Frontend

- [Session API](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api.md)
- [Terminology](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/session-api-terminology.md)
- [Setting up](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/spa-basics-setting-up.md)
- [Managing Sessions](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/spa-basics-managing-sessions.md)
- [Handling Placements](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/handling-placements.md)
- [Tracking Events](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/spa-basics-tracking-events.md)
- [Leveraging Features](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/spa-basics-leveraging-features.md)
- [Record Attribution](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/record-attributions.md)
- [Advanced Usage](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/advanced-usage.md)
- [Supporting opt-out and do-not-track](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/advanced-usage/spa-out-out-of-session-tracking.md)
- [Using external session identifiers](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/advanced-usage/spa-customizing-session-handling.md)
- [Adding support for multi-currency](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/advanced-usage/spa-adding-support-for-multi-currency.md)
- [Adding support for customer group pricing](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/advanced-usage/spa-adding-support-for-customer-group-pricing.md)
- [FAQ](https://docs.nosto.com/techdocs/apis/frontend/implementation-guide-session-api/spa-faq.md)
- [JS API](https://docs.nosto.com/techdocs/apis/frontend/js-apis.md)
- [Initializing Nosto](https://docs.nosto.com/techdocs/apis/frontend/js-apis/initializing-nosto.md)
- [Recommendations](https://docs.nosto.com/techdocs/apis/frontend/js-apis/recommendations.md)
- [Loading Recommendations](https://docs.nosto.com/techdocs/apis/frontend/js-apis/recommendations/loading-recommendations.md)
- [Recommendation Callbacks](https://docs.nosto.com/techdocs/apis/frontend/js-apis/recommendations/recommendation-callbacks.md)
- [Setting up dynamic filtering](https://docs.nosto.com/techdocs/apis/frontend/js-apis/recommendations/setting-up-dynamic-filtering.md)
- [Sending Product-View Events](https://docs.nosto.com/techdocs/apis/frontend/js-apis/recommendations/sending-product-view-events.md)
- [Sending Add to Cart-Events](https://docs.nosto.com/techdocs/apis/frontend/js-apis/recommendations/sending-add-to-cart-events.md)
- [Popups](https://docs.nosto.com/techdocs/apis/frontend/js-apis/popups.md)
- [Listing Popup Campaigns](https://docs.nosto.com/techdocs/apis/frontend/js-apis/popups/listing-popup-campaigns.md)
- [Opening a Popup](https://docs.nosto.com/techdocs/apis/frontend/js-apis/popups/opening-a-popup.md)
- [Enabling & Disabling Popups](https://docs.nosto.com/techdocs/apis/frontend/js-apis/popups/enabling-and-disabling-popups.md)
- [Popup Callbacks](https://docs.nosto.com/techdocs/apis/frontend/js-apis/popups/popup-callbacks.md)
- [Advanced Usage](https://docs.nosto.com/techdocs/apis/frontend/js-apis/common-examples.md)
- [Sending email addresses to Nosto](https://docs.nosto.com/techdocs/apis/frontend/js-apis/common-examples/sending-email-addresses-to-nosto.md)
- [Manually segmenting users](https://docs.nosto.com/techdocs/apis/frontend/js-apis/common-examples/manually-segmenting-users.md)
- [Dynamically sending the cart content](https://docs.nosto.com/techdocs/apis/frontend/js-apis/common-examples/dynamically-sending-the-cart-content.md): If you're on a site where the cart content is not accessible when the page is rendered, you might need to fetch the cart content over AJAX/CORS and send that information to Nosto.
- [Sending Customer Information](https://docs.nosto.com/techdocs/apis/frontend/js-apis/common-examples/sending-customer-information.md)
- [Record Attribution](https://docs.nosto.com/techdocs/apis/frontend/js-apis/record-attribution.md)
- [Open Source](https://docs.nosto.com/techdocs/apis/frontend/oss.md)
- [Nosto JS](https://docs.nosto.com/techdocs/apis/frontend/oss/nosto-js.md)
- [Search JS](https://docs.nosto.com/techdocs/apis/frontend/oss/search-js.md)
- [Nosto React](https://docs.nosto.com/techdocs/apis/frontend/oss/react-support.md)
- [Web Components](https://docs.nosto.com/techdocs/apis/frontend/oss/web-components.md)
- [Loading Web components](https://docs.nosto.com/techdocs/apis/frontend/oss/web-components/loading-web-components.md)
- [Shopify Integration](https://docs.nosto.com/techdocs/apis/frontend/oss/web-components/shopify-integration.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.nosto.com/techdocs/apis/frontend.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
